// SPDX-FileCopyrightText: 2008 Stuart Buchanan
// SPDX-License-Identifier: LGPL-2.1-or-later

#pragma once

#include <vector>
#include <string>

#include <osg/Geometry>
#include <osg/Group>
#include <osg/Matrix>
#include <osg/LOD>

#include <simgear/scene/util/OsgMath.hxx>

namespace simgear
{
class TreeBin final {
public:
    TreeBin() = default;
    TreeBin(const SGMaterial *mat);
    TreeBin(const SGPath& absoluteFileName, const SGMaterial *mat);

    ~TreeBin() = default;   // non-virtual intentional

    struct Tree {
        SGVec3f position;
        SGVec3f tnormal;
        Tree(const SGVec3f& p, const SGVec3f& t) : position(p), tnormal(t)
        {
        }
  };

    typedef std::vector<Tree> TreeList;

    int texture_varieties;
    double range;
    float height;
    float width;
    std::string texture;
    std::string teffect;
    
    void insert(const SGVec3f& p, const SGVec3f& tnorm)
    {
        _trees.emplace_back(Tree(p, tnorm));
    }

    unsigned getNumTrees() const
    { return _trees.size(); }

    const Tree getTree(unsigned i) const
    {
        assert(i < _trees.size());
        return _trees.at(i);
    }

    std::vector<Tree> _trees;
};

typedef std::list<TreeBin*> SGTreeBinList;

osg::Group* createForest(SGTreeBinList& forestList, const osg::Matrix& transform,
                         const SGReaderWriterOptions* options, int depth=3);
}

